SystemOrganization addCategory: #'Khami-Core'!
SystemOrganization addCategory: #'Khami-Core-Support'!

GRObject subclass: #KmGame
	instanceVariableNames: 'tileSet players board announcer currentTile roads farms villages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmGame class methodsFor: 'instance creation' stamp: 'StuartHerring 3/14/2011 10:06'!
testGame
	^self tileSet: KmTileSet testSet! !

!KmGame class methodsFor: 'instance creation' stamp: 'StuartHerring 3/14/2011 10:06'!
tileSet: aTileSet 
	^self basicNew
		initializeWithTileSet: aTileSet;
		yourself! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 19:33'!
board
	^board! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/16/2011 20:19'!
currentTile
	^currentTile! !

!KmGame methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 16:09'!
discardTile
	currentTile := nil! !

!KmGame methodsFor: 'initialization' stamp: 'StuartHerring 3/21/2011 22:09'!
initializeWithTileSet: aSet
	self initialize.
	tileSet := aSet.
	board := KmGameBoard startingTile: aSet takeTile.
	announcer := Announcer new.
	currentTile := nil.
	roads := OrderedCollection new.
	villages := OrderedCollection new.
	farms := OrderedCollection new.! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 12:08'!
placeTileAt: row at: column
	(currentTile notNil and: [(board at: row at: column) isNil]) 
		ifTrue: [ board at: row at: column put: currentTile.
			currentTile := nil]! !

!KmGame methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 16:04'!
takeTile
	^currentTile := currentTile ifNil: [tileSet takeTile].! !

!KmGame methodsFor: 'actions' stamp: 'StuartHerring 1/30/2011 22:55'!
territories
	| result |
	result := Set new.
	board do: [ :tile | result addAll: tile territories].
	^result! !

!KmGame methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 11:56'!
tileSet
	^tileSet! !

!KmGame methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 13:39'!
validMoveAvailable
	^currentTile ifNil: [false]
		ifNotNil: [ | tile | 
			tile := currentTile veryDeepCopy.
			(1 to: board rows) anySatisfy: [ :r | 
				(1 to: board columns) anySatisfy: [ :c | 
					(1 to: 4) anySatisfy: [ :i | 
						tile rotate. 
						(board canPlaceTile: tile at:  r at: c)]]]].
! !

GRObject subclass: #KmGameBoard
	instanceVariableNames: 'board startingTile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmGameBoard class methodsFor: 'instance creation' stamp: 'StuartHerring 3/7/2011 20:23'!
startingTile: aTile
	^self basicNew
		initializeWithStartingTile: aTile;
		yourself.! !

!KmGameBoard methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 22:39'!
at: row at: column
	(row < 1 or: [column < 1 or: [row > board rows or: [column > board columns]]]) ifTrue: [^nil].
	^board at: row at: column! !

!KmGameBoard methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 22:34'!
at: row at: column put: aTile
	board at: row at: column put: aTile.
	self connectTilesAt: row at: column.
	(row = 1) ifTrue: [ board prependRow].
	(row = board rows) ifTrue: [board addRow].
	(column = 1) ifTrue: [ board prependColumn ].
	(column = board columns) ifTrue: [ board addColumn].! !

!KmGameBoard methodsFor: 'testing' stamp: 'StuartHerring 1/18/2011 19:17'!
canPlaceTile: aTile at: row at: column
	(board at: row at: column) ifNotNil: [^false].
	((board adjacentItemsAt: row at: column) noneSatisfy: [ :item | item notNil])
		ifTrue: [ ^false ].
	^KmLocation edges 
		allSatisfy: [ :side | self canPlaceTile: aTile toThe: side of: row and: column]
! !

!KmGameBoard methodsFor: 'testing' stamp: 'StuartHerring 1/18/2011 19:27'!
canPlaceTile: aTile toThe: aSide of: row and: column
	| r c |
	(aSide = Left) ifTrue: [ c := column - 1 ] 
		ifFalse: [ (aSide = Right) ifTrue: [ c := column + 1] ifFalse: [ c := column]].
	(aSide = Top) ifTrue: [ r := row - 1 ] 
		ifFalse: [ (aSide = Bottom) ifTrue: [ r := row + 1] ifFalse: [ r := row]].
	((r < 1) or: [c < 1]) ifTrue: [^true].
	((r > board rows) or: [c > board columns]) ifTrue: [^true].
	(board at: r at: c) ifNil: [^true].
	^(board at: r at: c) allowsTile: aTile at: aSide opposite! !

!KmGameBoard methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 19:38'!
columns
	^board columns! !

!KmGameBoard methodsFor: 'actions' stamp: 'StuartHerring 1/30/2011 22:43'!
connectTilesAt: row at: column
	| tile |
	tile := board at: row at: column.
	tile tileAt: Top put: (self at: row - 1at: column).
	tile tileAt: Bottom put: (self at: row + 1at: column).
	tile tileAt: Left put: (self at: row at: column - 1).
	tile tileAt: Right put: (self at: row at: column + 1).
	! !

!KmGameBoard methodsFor: 'enumerating' stamp: 'StuartHerring 1/30/2011 23:05'!
do: aBlock
	^board do: [ :tile | tile ifNotNil: [ aBlock value: tile]]! !

!KmGameBoard methodsFor: 'initialization' stamp: 'StuartHerring 3/7/2011 20:22'!
initializeWithStartingTile: aTile
	self initialize.
	startingTile := aTile.
	board := KmGrid ofSize: 3 by: 3.
	board at: 2 at: 2 put: startingTile! !

!KmGameBoard methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 19:38'!
rows
	^board rows! !

!KmGameBoard methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 19:46'!
startingTile
	^startingTile! !

GRObject subclass: #KmGrid
	instanceVariableNames: 'rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core-Support'!

!KmGrid class methodsFor: 'instance creation' stamp: 'StuartHerring 1/10/2011 14:30'!
ofSize: rows by: columns
	^self new
		addColumns: columns;
		addRows: rows;
		yourself.! !

!KmGrid methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 11:18'!
addColumn
	self addColumns: 1! !

!KmGrid methodsFor: 'actions' stamp: 'StuartHerring 1/10/2011 14:28'!
addColumns: aNumber
	rows do:  [:row |
		aNumber timesRepeat: [ row add: nil ]].
	cols := cols + aNumber.
		! !

!KmGrid methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 11:20'!
addRow
	self addRows: 1! !

!KmGrid methodsFor: 'actions' stamp: 'StuartHerring 1/10/2011 14:07'!
addRows: aNumber
	aNumber timesRepeat:  [
		rows add: (OrderedCollection ofSize: cols)]! !

!KmGrid methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2011 19:22'!
adjacentItemsAt: row at: column
	| return |
	return := OrderedCollection new.
	(row > 1) ifTrue: [ return add: (self at: row -1 at: column)].
	(column < cols) ifTrue: [ return add: (self at: row at: column + 1)].
	(row < rows size) ifTrue: [ return add: (self at: row  +1 at: column)].
	(column > 1) ifTrue: [ return add: (self at: row at: column - 1)].
	^return! !

!KmGrid methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 09:44'!
at: row at: column
	^(rows at: row) at: column ! !

!KmGrid methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 11:11'!
at: row at: column put: data
	(rows at: row) at: column put: data! !

!KmGrid methodsFor: 'accessing' stamp: 'StuartHerring 1/10/2011 11:59'!
columns
	^cols! !

!KmGrid methodsFor: 'enumerating' stamp: 'StuartHerring 1/30/2011 23:03'!
do: aBlock
	^rows do: [ :r | r do: [ :c | aBlock value: c]]! !

!KmGrid methodsFor: 'initialization' stamp: 'StuartHerring 1/10/2011 12:12'!
initialize
	super initialize.
	rows := OrderedCollection new.
	cols := 0.! !

!KmGrid methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 11:50'!
prependColumn
	rows do:  [:row |
		 row addFirst: nil ].
	cols := cols + 1.
		! !

!KmGrid methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 11:48'!
prependRow
	rows addFirst: (OrderedCollection ofSize: cols)! !

!KmGrid methodsFor: 'accessing' stamp: 'StuartHerring 1/10/2011 11:59'!
rows
	^rows size! !

GRObject subclass: #KmLocation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmLocation subclass: #BottomLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!BottomLeft class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:33'!
connectingLocations
	^{LeftBottom. CentreLeft. Bottom}! !

!BottomLeft class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:24'!
edge
	^Bottom! !

!BottomLeft class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:18'!
opposite
	^TopLeft! !

KmLocation subclass: #BottomRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!BottomRight class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:33'!
connectingLocations
	^{Bottom. CentreRight. RightBottom}! !

!BottomRight class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:36'!
edge
	^Bottom! !

!BottomRight class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:19'!
opposite
	^TopRight! !

KmLocation subclass: #Centre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Centre class methodsFor: 'accessing' stamp: 'StuartHerring 4/16/2011 10:58'!
connectingLocations
	^{CentreTop. CentreRight. CentreBottom. CentreLeft}! !

!Centre class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:37'!
edge
	self shouldNotImplement! !

!Centre class methodsFor: 'accessing' stamp: 'StuartHerring 4/20/2011 17:10'!
isAtEdge
	^false! !

!Centre class methodsFor: 'testing' stamp: 'StuartHerring 4/22/2011 14:00'!
isCentre
	^true! !

!Centre class methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:21'!
opposite
	self shouldNotImplement! !

Centre subclass: #CentreBottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!CentreBottom class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 16:16'!
connectingLocations
	^{Centre. RightBottom. Bottom. LeftBottom.}! !

Centre subclass: #CentreLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!CentreLeft class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 13:04'!
connectingLocations
	^{TopLeft. Centre. BottomLeft. Left}. ! !

Centre subclass: #CentreRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!CentreRight class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 13:04'!
connectingLocations
	^{TopRight. Right. BottomRight. Centre.}! !

Centre subclass: #CentreTop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!CentreTop class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 16:19'!
connectingLocations
	^{Top. RightTop. Centre. LeftTop.}! !

KmLocation subclass: #KmEdge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmEdge subclass: #Bottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Bottom class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 16:20'!
connectingLocations
	^{BottomLeft. CentreBottom. BottomRight}! !

!Bottom class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:01'!
locations
	^{BottomRight. Bottom. BottomLeft}! !

!Bottom class methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:18'!
opposite
	^Top! !

!KmEdge class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:24'!
edge
	^self! !

!KmEdge class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 15:41'!
locations
	"The locations on this edge"
	self subclassResponsibility.! !

KmEdge subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Left class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 13:05'!
connectingLocations
	^{LeftBottom. CentreLeft. LeftTop}. ! !

!Left class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:01'!
locations
	^{LeftTop. Left. LeftBottom.}! !

!Left class methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite 
	^Right! !

KmEdge subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Right class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 13:05'!
connectingLocations
	^{RightBottom. CentreRight. RightTop}! !

!Right class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:02'!
locations
	^{RightTop. Right. RightBottom.}! !

!Right class methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite
	^Left! !

KmEdge subclass: #Top
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!Top class methodsFor: 'accessing' stamp: 'StuartHerring 4/21/2011 13:05'!
connectingLocations
	^{TopLeft. CentreTop. TopRight}! !

!Top class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:02'!
locations
	^{TopLeft. Top. TopRight}! !

!Top class methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:19'!
opposite
	^Bottom! !

!KmLocation class methodsFor: 'grouping' stamp: 'StuartHerring 4/20/2011 17:05'!
all
	^{Centre. 
		TopLeft. Top. CentreTop. TopRight. 
		RightTop.  Right. CentreRight. RightBottom. 
		BottomRight. Bottom. CentreBottom. BottomLeft. 
		LeftBottom. Left. CentreLeft. LeftTop}! !

!KmLocation class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 15:53'!
connectingLocations
	"The locations directly reachable from this location, starting from the right"
	self subclassResponsibility! !

!KmLocation class methodsFor: 'accessing' stamp: 'StuartHerring 3/6/2011 12:13'!
edge
	"The edge this location is on"
	self subclassResponsibility.! !

!KmLocation class methodsFor: 'grouping' stamp: 'StuartHerring 1/12/2011 13:22'!
edges
	^{Top. Right. Bottom. Left.}! !

!KmLocation class methodsFor: 'grouping' stamp: 'StuartHerring 4/20/2011 17:09'!
isAtEdge
	^true! !

!KmLocation class methodsFor: 'testing' stamp: 'StuartHerring 4/22/2011 14:00'!
isCentre
	^false! !

!KmLocation class methodsFor: 'accessing' stamp: 'StuartHerring 3/6/2011 12:13'!
opposite
	"The location that corresponds to this location on an adjacent tile"
	^self subclassResponsibility! !

!KmLocation class methodsFor: 'grouping' stamp: 'StuartHerring 1/12/2011 13:22'!
pathLocations
	^{Top. Right. Bottom. Left. Centre}! !

KmLocation subclass: #LeftBottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!LeftBottom class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:35'!
connectingLocations
	^{Left. CentreBottom. BottomLeft}! !

!LeftBottom class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:37'!
edge
	^Left! !

!LeftBottom class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:19'!
opposite
	^RightBottom! !

KmLocation subclass: #LeftTop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!LeftTop class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:35'!
connectingLocations
	^{TopLeft. CentreTop. Left}! !

!LeftTop class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:37'!
edge
	^Left! !

!LeftTop class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^RightTop! !

KmLocation subclass: #RightBottom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!RightBottom class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:36'!
connectingLocations
	^{BottomRight. CentreBottom. Right}! !

!RightBottom class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:37'!
edge
	^Right! !

!RightBottom class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^LeftBottom! !

KmLocation subclass: #RightTop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!RightTop class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:36'!
connectingLocations
	^{Right. CentreTop. TopRight}! !

!RightTop class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:37'!
edge
	^Right! !

!RightTop class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^LeftTop! !

KmLocation subclass: #TopLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!TopLeft class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:37'!
connectingLocations
	^{Top. CentreLeft. LeftTop}! !

!TopLeft class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:38'!
edge
	^Top! !

!TopLeft class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^BottomLeft! !

KmLocation subclass: #TopRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!TopRight class methodsFor: 'accessing' stamp: 'StuartHerring 4/22/2011 13:37'!
connectingLocations
	^{RightTop. CentreRight. Top}! !

!TopRight class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 21:38'!
edge
	^Top! !

!TopRight class methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 18:21'!
opposite
	^BottomRight! !

GRObject subclass: #KmPiece
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmPiece class methodsFor: 'instance creation' stamp: 'StuartHerring 1/7/2011 15:07'!
forPlayer: aPlayer
	^self basicNew
		initializeWithPlayer: aPlayer;
		yourself! !

!KmPiece methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2011 15:06'!
initializeWithPlayer: aPlayer
	self initialize.
	player := aPlayer! !

GRObject subclass: #KmPlayer
	instanceVariableNames: 'pieces colour name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

GRObject subclass: #KmTerritory
	instanceVariableNames: 'segments complete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTerritory methodsFor: 'adding' stamp: 'StuartHerring 1/30/2011 23:52'!
add: aSegment
	segments add: aSegment.
! !

!KmTerritory methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 21:49'!
initialize
	super initialize.
	segments := Set new.
	complete := false.! !

!KmTerritory methodsFor: 'testing' stamp: 'StuartHerring 1/31/2011 21:23'!
isComplete
	^complete or: [ complete := segments noneSatisfy: [ :s | s isAtEdge]]! !

!KmTerritory methodsFor: 'testing' stamp: 'StuartHerring 1/30/2011 17:55'!
isEmpty
	^self size = 0.! !

!KmTerritory methodsFor: 'merging' stamp: 'StuartHerring 1/30/2011 23:53'!
mergeWith: aTerritory
	"Removes all segments from this territory and puts them in the provided one"
	aTerritory == self ifFalse: [
		segments do: [ :s | s territory: aTerritory].
		segments removeAll.
		aTerritory isComplete ifTrue: [
			aTerritory signalCompleteness]].! !

!KmTerritory methodsFor: 'notifying' stamp: 'StuartHerring 1/31/2011 21:21'!
signalCompleteness
	! !

!KmTerritory methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:08'!
size
	^segments size! !

!KmTerritory methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 19:37'!
tiles
	^Set withAll: (segments collect: [:s | s tile])! !

!KmTerritory methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 23:06'!
type
	^segments any type.! !

GRObject subclass: #KmTile
	instanceVariableNames: 'regions regionMap tiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTile class methodsFor: 'standard tiles' stamp: 'StuartHerring 3/7/2011 19:57'!
blank
	"Creates a blank tile consisting of nothing but farm"
	^self buildFromString: 'FFFFFFFFF'.! !

!KmTile class methodsFor: 'instance creation' stamp: 'StuartHerring 3/7/2011 19:57'!
buildFromString: aString
	^self new
		buildFromString: aString;
		yourself! !

!KmTile class methodsFor: 'standard tiles' stamp: 'StuartHerring 3/7/2011 21:17'!
startingTile
	"Creates the standard starting tile of a village with a road going past it"
	^self buildFromString: 'VFFFV-F--'.! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 19:02'!
allowsTile: aTile at: aSide
	(self tileAt: aSide) ifNotNil: [ ^false].
	aSide locations do: [ :r | ((self at: r) connectsTo: (aTile at: r opposite)) ifFalse: [ ^false]].
	^true! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/28/2011 20:31'!
at: aSymbol
	^regions at: (regionMap at: aSymbol)! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:58'!
buildCentreSegmentFrom: char at: index
	(regions at: index  put: (KmTileSegment fromCentreChar: char in: self))
		location: (regionMap keyAtValue: index)! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 17:44'!
buildFromStream: aStream
	1 to: 4 do: [ :i | self buildSideFrom: aStream next at: i ].
	1 to: 5 do: [ :i | self buildPathFrom: aStream next at: i ].
	self calculateTerritories! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 18:55'!
buildFromString: aString
	self buildFromStream: (ReadStream on: aString)! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:57'!
buildPathFrom: char at: index
	index = 5 ifTrue: [self buildSegmentFrom: char at: 0]
		ifFalse: [
			self buildSegmentFrom: char at: index * 4 - 2.
			self buildCentreSegmentFrom: char at: index * 4 - 1]! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 17:45'!
buildSegmentFrom: char at: index
	(regions at: index  put: (KmTileSegment fromChar: char in: self))
		location: (regionMap keyAtValue: index)! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 4/20/2011 16:53'!
buildSideFrom: char at: index
	self buildSegmentFrom: char at:  index * 4 - 3.
	self buildSegmentFrom: char at:  index * 4.! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 21:13'!
calculateTerritories
	KmLocation all do: [ :r | | seg1 | seg1 := (self at: r).
		r connectingLocations do: [ :r2 | | seg2 | seg2 := (self at: r2).
			(seg1 connectsTo: seg2) 
				ifTrue: [	seg2 territory mergeWith: seg1 territory]]].! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 4/20/2011 17:02'!
initialize
	super initialize.
	tiles := Dictionary new.
	regions := Dictionary new.
	regionMap := Dictionary new.
	KmLocation all
		keysAndValuesDo: [ :index :region | regionMap at: region put: index - 1 ].! !

!KmTile methodsFor: 'actions' stamp: 'StuartHerring 4/21/2011 12:59'!
rotate
	regionMap keysAndValuesDo: [ :key : value |
		value = 0 ifFalse: [ | new |
			new := ((value + 11 ) \\ 16) + 1.
			regionMap at: key put: new.
			(regions at: new) location: key]].! !

!KmTile methodsFor: 'initialization' stamp: 'StuartHerring 1/30/2011 21:14'!
territories
	^Set new 
		addAll: (regions select: [ :r | r territory notNil ] thenCollect: [ :r | r territory]);
		yourself! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2011 13:10'!
tileAt: aDirection
	^tiles at: aDirection ifAbsent: [nil]! !

!KmTile methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 22:43'!
tileAt: aDirection put: aTile
	aTile ifNil: [^nil].
	tiles at: aDirection ifAbsent: [
		tiles at: aDirection put: aTile.
		aTile tileAt: aDirection opposite put: self].
	aDirection locations do: [ :loc | (self at: loc) territory mergeWith: (aTile at: loc opposite) territory].
	^aTile! !

GRObject subclass: #KmTileSegment
	instanceVariableNames: 'territory tile location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmTileSegment subclass: #KmBlocker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmBlocker class methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 17:57'!
codeCharacter
	^$.! !

!KmBlocker methodsFor: 'testing' stamp: 'StuartHerring 1/31/2011 23:12'!
isComplete
	^false.! !

!KmBlocker methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 18:23'!
territory
	^nil! !

!KmBlocker methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 18:24'!
territory: aTerritory
	"do nothing"! !

!KmBlocker methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 23:06'!
type
	^#blocker! !

KmBlocker subclass: #KmWitchdoctor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmWitchdoctor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2011 22:53'!
codeCharacter
	^$+! !

KmTileSegment subclass: #KmPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmPath methodsFor: 'testing' stamp: 'StuartHerring 1/29/2011 12:13'!
isPath
	^true! !

KmPath subclass: #KmRoadPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmRoadPath class methodsFor: 'accessing' stamp: 'StuartHerring 1/8/2011 22:59'!
codeCharacter
	^$-! !

!KmRoadPath methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:50'!
connectsTo: aSegment
	^aSegment isRoad! !

!KmRoadPath methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:58'!
isRoad
	^true! !

!KmRoadPath methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 23:07'!
type
	^#road! !

KmTileSegment subclass: #KmRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmRegion subclass: #KmFarmRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmFarmRegion class methodsFor: 'accessing' stamp: 'StuartHerring 1/8/2011 22:42'!
codeCharacter
	^$F! !

!KmFarmRegion methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:51'!
connectsTo: aSegment
	^aSegment isFarm! !

!KmFarmRegion methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:10'!
isFarm
	^true! !

!KmFarmRegion methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 23:07'!
type
	^#farm! !

KmRegion subclass: #KmVillageRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

KmVillageRegion subclass: #KmHalfVillageRegion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmHalfVillageRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/25/2011 15:48'!
centreRegion
	^KmFarmRegion! !

!KmHalfVillageRegion class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/25/2011 15:55'!
codeCharacter
	^$v! !

!KmVillageRegion class methodsFor: 'accessing' stamp: 'StuartHerring 1/8/2011 22:42'!
codeCharacter
	^$V! !

!KmVillageRegion methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:51'!
connectsTo: aSegment
	^aSegment isVillage! !

!KmVillageRegion methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 23:11'!
isVillage
	^true! !

!KmVillageRegion methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 23:07'!
type
	^#village! !

KmVillageRegion subclass: #KmVillageWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmVillageWall class methodsFor: 'accessing' stamp: 'StuartHerring 1/31/2011 23:00'!
codeCharacter
	^$W! !

!KmVillageWall methodsFor: 'testing' stamp: 'StuartHerring 1/31/2011 23:01'!
connectsTo: aSegment
	^aSegment isWall not and: [super connectsTo: aSegment]! !

!KmVillageWall methodsFor: 'testing' stamp: 'StuartHerring 1/31/2011 23:02'!
isWall
	^true! !

!KmTileSegment class methodsFor: 'accessing' stamp: 'StuartHerring 4/25/2011 15:47'!
centreRegion
	"Answers a Segment class to use in the centre for this type"
	^self! !

!KmTileSegment class methodsFor: 'accessing' stamp: 'StuartHerring 1/29/2011 12:44'!
codeCharacter
	^nil! !

!KmTileSegment class methodsFor: 'instance creation' stamp: 'StuartHerring 4/25/2011 15:58'!
fromCentreChar: aChar in: aTile
	^(self allSubclasses detect: [ :class | 
		(class isAbstract not) and: [class codeCharacter = aChar]]) centreRegion inTile: aTile.! !

!KmTileSegment class methodsFor: 'instance creation' stamp: 'StuartHerring 3/6/2011 12:43'!
fromChar: aChar in: aTile
	^(self allSubclasses detect: [ :class | 
		(class isAbstract not) and: [class codeCharacter = aChar]]) inTile: aTile.! !

!KmTileSegment class methodsFor: 'instance creation' stamp: 'StuartHerring 3/6/2011 12:42'!
inTile: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileSegment class methodsFor: 'testing' stamp: 'StuartHerring 1/29/2011 12:46'!
isAbstract
	^self codeCharacter isNil! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 17:42'!
connectsTo: aSegment
	^false! !

!KmTileSegment methodsFor: 'initialization' stamp: 'StuartHerring 1/31/2011 21:21'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.
	self territory: KmTerritory new.! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 4/22/2011 14:02'!
isAtEdge
	^location isNil or: [
		location isCentre 
			ifTrue: [false]
			ifFalse: [(tile tileAt: location edge) isNil]]! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/31/2011 21:21'!
isComplete
	^territory isComplete! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/8/2011 22:59'!
isFarm 
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/29/2011 12:12'!
isPath
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 17:15'!
isRoad
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/30/2011 17:50'!
isVillage 
	^false! !

!KmTileSegment methodsFor: 'testing' stamp: 'StuartHerring 1/31/2011 23:00'!
isWall
	^false! !

!KmTileSegment methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:16'!
location
	^location! !

!KmTileSegment methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:23'!
location: aLocation
	location := aLocation.! !

!KmTileSegment methodsFor: 'printing' stamp: 'StuartHerring 1/30/2011 18:20'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ', '.
	aStream nextPutAll: location name! !

!KmTileSegment methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 14:02'!
territory
	^territory! !

!KmTileSegment methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 17:48'!
territory: aTerritory
	territory := aTerritory.
	aTerritory add: self.! !

!KmTileSegment methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 16:16'!
tile
	^tile! !

!KmTileSegment methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2011 23:06'!
type
	self subclassResponsibility ! !

Object subclass: #KmTileSet
	instanceVariableNames: 'tiles name'
	classVariableNames: 'TileSets'
	poolDictionaries: ''
	category: 'Khami-Core'!

KmTileSet subclass: #KmTStestSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Core'!

!KmTStestSet class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/21/2011 23:11'!
new
	^self buildFromStrings: #('VFFFV-F--' 'VVFFVVFFF' 'FFFF--FF-' 'FFFF--FF-' 'FFFF-FFFF' 'FFFFF-F--' 'VFFFVF---' 'WWWWVVVV.' 'FFFVF-FVV' 'VVVFVVVFF' 'VVVVVVVVV' 'VVVFVVVFF' 'VFFFVFFFF' 'FFFFFFFFF' 'VVVFVVV-V' 'VFFFVFFFF' 'VVFFVVFFF' 'VFVFV-V--' 'VFFFV--F-' 'FFFFF-F--' 'FVFVFVFVV' 'FVFV-V-VV' 'WWFFVVFFF')! !

!KmTStestSet class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/21/2011 23:04'!
tilesetName
	^'Test Set'! !

!KmTileSet class methodsFor: 'instance creation' stamp: 'StuartHerring 3/21/2011 23:00'!
buildFromStrings: aCollection
	^self buildFromTiles: 
		(aCollection select: [:string | string withBlanksTrimmed notEmpty] 
			thenCollect: [ :string | KmTile buildFromString: string ]) asOrderedCollection! !

!KmTileSet class methodsFor: 'instance creation' stamp: 'StuartHerring 3/21/2011 22:59'!
buildFromTiles: aCollection
	^self basicNew
		initializeWithTiles: aCollection asOrderedCollection;
		yourself.! !

!KmTileSet class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 15:31'!
initialize
	TileSets := Set new.! !

!KmTileSet class methodsFor: 'instance creation' stamp: 'StuartHerring 3/21/2011 19:03'!
new
	self subclassResponsibility! !

!KmTileSet class methodsFor: 'tile sets' stamp: 'StuartHerring 3/21/2011 21:19'!
prefix
	^'KmTS'! !

!KmTileSet class methodsFor: 'tile sets' stamp: 'StuartHerring 3/21/2011 23:03'!
register: aName asTileSetUsingStrings: aCollection
	| tileSetClass source |
	tileSetClass := self 
		subclass: (self prefix, aName asLegalSelector) asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Khami-Generated-Tilesets'.
	source := '' writeStream.
	source nextPutAll: 'new
	^self buildFromStrings:'.
	source nextPutAll: aCollection asArray printString.
	tileSetClass class compile: source contents.
	tileSetClass class compile: 'tilesetName
	^', aName printString.! !

!KmTileSet class methodsFor: 'instance creation' stamp: 'StuartHerring 3/24/2011 20:24'!
register: aName fromFileNamed: aFilePath
	^self register: aName asTileSetUsingStrings: 	
		((FileStream fileNamed: aFilePath) contents splitOn: Character lf)
	! !

!KmTileSet class methodsFor: 'instance creation' stamp: 'StuartHerring 3/24/2011 20:26'!
registerFromDirectory: aName
	| basedir |
	basedir := FileDirectory on: Smalltalk imagePath.
	^self register: aName fromFileNamed:	
		(((basedir directoryNamed: aName)	fileNamed: 'set.txt'))! !

!KmTileSet class methodsFor: 'tile sets' stamp: 'StuartHerring 3/21/2011 22:11'!
testSet
	^KmTStestSet new! !

!KmTileSet class methodsFor: 'tile sets' stamp: 'StuartHerring 3/21/2011 19:04'!
tileSets
	^self allSubclasses! !

!KmTileSet class methodsFor: 'instance creation' stamp: 'StuartHerring 3/21/2011 23:04'!
tilesetName
	self subclassResponsibility! !

!KmTileSet methodsFor: 'enumerating' stamp: 'StuartHerring 3/7/2011 21:28'!
do: aBlock
	^tiles do: aBlock! !

!KmTileSet methodsFor: 'initialization' stamp: 'StuartHerring 3/26/2011 09:51'!
initializeWithTiles: aCollection
	self initialize.
	tiles := OrderedCollection new
		add: aCollection first;
		addAll: aCollection copyWithoutFirst shuffled;
		yourself! !

!KmTileSet methodsFor: 'initialization' stamp: 'StuartHerring 3/21/2011 22:58'!
name
	^self class tilesetName! !

!KmTileSet methodsFor: 'accessing' stamp: 'StuartHerring 3/7/2011 20:31'!
size
	^tiles size.! !

!KmTileSet methodsFor: 'actions' stamp: 'StuartHerring 3/7/2011 20:44'!
takeTile
	^tiles removeFirst! !
KmTileSet initialize!
